﻿using System;
using System.Collections;
using System.Data;
using System.Web.UI.WebControls;
using lnt.EIPVidhya.EDMS.EIPEDMSService;
using lntSPDAL;
using Microsoft.SharePoint.WebControls;

namespace lnt.EIPVidhya.EDMS.Layouts.EDMS
{
    public partial class ProjectAlertMembers : LayoutsPageBase
    {
        string ECC_Web_Login;
        int Project_Id = 0;
        string Member;
        string Group_Id;

        protected void Page_Load(object sender, EventArgs e)
        {
            lntSPCurrentSite objCurrentSite = new lntSPCurrentSite();
            lntSPCurrentUser objCurrentUser = new lntSPCurrentUser();
            EIPEDMS objEDMS = new EIPEDMS();

            ECC_Web_Login = objCurrentUser.LoginName;


            DataSet dsProject = objEDMS.Get_Project_Id(objCurrentSite.WebSiteURL);

            if (dsProject.Tables.Count > 0 && dsProject.Tables[0].Rows.Count > 0)
            {
                Project_Id = Convert.ToInt32(dsProject.Tables[0].Rows[0]["Project_Id"]);

            }

            DataSet dsUser = objEDMS.Get_Project_User_Details(ECC_Web_Login, Project_Id.ToString());

            if (dsUser.Tables[0].Rows.Count > 0)
            {
                Member = dsUser.Tables[0].Rows[0]["Member_Id"].ToString();
                Group_Id = dsUser.Tables[0].Rows[0]["Group_Id"].ToString();

                DataSet dsRole = objEDMS.Get_Project_Member_Roles(Convert.ToString(Project_Id), Member);

                DataRow[] drRole = dsRole.Tables[0].Select("Role_Id=352");

                if (drRole.Length == 0)
                {
                    MsgBox1.alert("You are not authorized to view this page", objCurrentSite.WebSiteURL);
                }
            }
            else
            {
                MsgBox1.alert("You are not authorized to view this page", objCurrentSite.WebSiteURL);
                return;
            }

            if (!IsPostBack)
            {
                Bind_Project();
                Sorting();
            }

        }
        protected void Bind_Project()
        {
            EIPEDMS objEDMS = new EIPEDMS();
            DataSet ds = new DataSet();
            ds = objEDMS.Get_Drawing_Project_Details("Fetch", "");
            ddlProject.DataSource = ds;
            ddlProject.DataTextField = "PROJECT_DESC";
            ddlProject.DataValueField = "project_Id";
            ddlProject.DataBind();


            ListItem li = new ListItem();
            li.Text = "--Select--";
            li.Value = "Select";
            ddlProject.Items.Insert(0, li);

        }

        protected void ddlProject_OnSelectedIndexChanged(object sender, EventArgs e)
        {

            EIPEDMS objEDMS = new EIPEDMS();
            if (ddlProject.SelectedValue != "Select")
            {

                DataSet dsPAM = objEDMS.Get_Project_Alert_Member(ddlProject.SelectedValue);

                ViewState["PAM"] = dsPAM.Tables[0];

                DataView dvTo = dsPAM.Tables[0].DefaultView;
                dvTo.RowFilter = "Receiver_Type=2";
                gvTo.DataSource = dvTo;
                gvTo.DataBind();
                
                for (int i = 0; i < gvTo.Rows.Count; i++)
                {
                   
                    DropDownList ddl = (DropDownList)gvTo.Rows[i].FindControl("ddlSortTo");
                    ddl.SelectedValue = dvTo.ToTable().Rows[i]["Sort_By"].ToString();

                }

                DataView dvCc = dsPAM.Tables[0].DefaultView;
                dvCc.RowFilter = "Receiver_Type=3";
                gvCc.DataSource = dvCc;
                gvCc.DataBind();

                for (int i = 0; i < gvCc.Rows.Count; i++)
                {
                    DropDownList ddl = (DropDownList)gvCc.Rows[i].FindControl("ddlSortCc");
                    ddl.SelectedValue = dvCc.ToTable().Rows[i]["Sort_By"].ToString();

                }

                DataView dvBcc = dsPAM.Tables[0].DefaultView;
                dvBcc.RowFilter = "Receiver_Type=4";
                gvBcc.DataSource = dvBcc;
                gvBcc.DataBind();

                for (int i = 0; i < gvBcc.Rows.Count; i++)
                {
                    DropDownList ddl = (DropDownList)gvBcc.Rows[i].FindControl("ddlSortBcc");
                    ddl.SelectedValue = dvBcc.ToTable().Rows[i]["Sort_By"].ToString();

                }

                Bind_Business_Group(ddlProject.SelectedValue);
                Bind_Member();
            }

        }

        private void Bind_Business_Group(string Project_Id)
        {

            EIPEDMS objEDMS = new EIPEDMS();

            DataSet ds = objEDMS.Get_Project_Business_Groups(Project_Id);
            ddlBusinessGroup.DataSource = ds;
            ddlBusinessGroup.DataTextField = "Group_Name";
            ddlBusinessGroup.DataValueField = "Group_Id";
            ddlBusinessGroup.DataBind();



        }
        protected void ddlBusinessGroup_SelectedIndexChanged(object sender, EventArgs e)
        {

            Bind_Member();

        }
        protected void Bind_Member()
        {
            EIPEDMS objEDMS = new EIPEDMS();
            DataSet ds = objEDMS.Get_Drawing_Project_Member("Fetch", Convert.ToString(Project_Id), ddlBusinessGroup.SelectedValue);
            DataTable dt = ds.Tables[0];
            dt.DefaultView.Sort = "Member_Desc";
            lstMember.DataSource = dt;
            lstMember.DataTextField = "Member_Name";
            lstMember.DataValueField = "Member_Id";
            lstMember.DataBind();


        }
        
        private void Sorting()
        {
            DataTable dt = new DataTable();

            DataColumn dc = new DataColumn("Member_Id");
            dc.DataType = System.Type.GetType("System.Int32");

            DataColumn dcSort = new DataColumn("Sort_By");
            dcSort.DataType = System.Type.GetType("System.Int16");

            DataColumn dcReceiverType = new DataColumn("Receiver_Type");
            dcReceiverType.DataType = System.Type.GetType("System.Int16");

            dt.Columns.Add("Member_Name");
            dt.Columns.Add(dc);
            dt.Columns.Add(dcSort);
            dt.Columns.Add(dcReceiverType);

            DataColumn[] dtAttachmentPK = new DataColumn[1];
            dtAttachmentPK[0] = dt.Columns["Member_Id"];
            dt.PrimaryKey = dtAttachmentPK;

            ViewState["PAM"] = dt;
        }

        protected void btnSAVE_Click(object sender, EventArgs e)
        {
            EIPEDMS objEDMS = new EIPEDMS();
            string Result = "";

            foreach (GridViewRow gvrTo in gvTo.Rows)
            {
                Label lblMember_Id = gvrTo.FindControl("lblMember_Id") as Label;
                DropDownList ddlSortTo = gvrTo.FindControl("ddlSortTo") as DropDownList;

                Result = objEDMS.Insert_Project_Alert_Members(ddlProject.SelectedValue, lblMember_Id.Text, "Y", Member, "2", ddlSortTo.SelectedValue);
            }

            foreach (GridViewRow gvrCc in gvCc.Rows)
            {
                Label lblMember_Id = gvrCc.FindControl("lblMember_Id") as Label;
                DropDownList ddlSortCc = gvrCc.FindControl("ddlSortCc") as DropDownList;

                Result = objEDMS.Insert_Project_Alert_Members(ddlProject.SelectedValue, lblMember_Id.Text, "Y", Member, "3",ddlSortCc.SelectedValue);
            }
            foreach (GridViewRow gvrBcc in gvBcc.Rows)
            {
                Label lblMember_Id = gvrBcc.FindControl("lblMember_Id") as Label;
                DropDownList ddlSortBcc = gvrBcc.FindControl("ddlSortBcc") as DropDownList;

                Result = objEDMS.Insert_Project_Alert_Members(ddlProject.SelectedValue, lblMember_Id.Text, "Y", Member, "4",ddlSortBcc.SelectedValue);
            }

        }

        protected void btnToAdd_OnClick(object sender, EventArgs e)
        {
            EIPEDMS objEDMS =new EIPEDMS();
            DataTable dtTo = ViewState["PAM"] as DataTable;

            DataRow drTo;
            
            if (lstMember.SelectedIndex > -1)
            {
                for (int i = 0; i < lstMember.Items.Count; i++)
                {
                    if (lstMember.Items[i].Selected)
                    {
                        DataColumn[] dtToAttachmentPK = new DataColumn[1];
                        dtToAttachmentPK[0] = dtTo.Columns["Member_Id"];
                        dtTo.PrimaryKey = dtToAttachmentPK;

                        if (dtTo.Rows.Find(lstMember.Items[i].Value) == null)
                        {
                            
                                drTo = dtTo.NewRow();
                                drTo["Member_Name"] = lstMember.Items[i].Text;
                                drTo["Member_Id"] = lstMember.Items[i].Value;
                                if (gvTo.Rows.Count >= 0)
                                {
                                    for (int j = 0; j <= gvTo.Rows.Count; j++)
                                    {
                                        drTo["Sort_By"] = 1 + j;
                                    }
                                }
                                drTo["Receiver_Type"] = "2";

                                dtTo.Rows.Add(drTo);
                               
                        }
                    }
                }
            }

            ViewState["PAM"] = dtTo;

            DataView dvTo = dtTo.DefaultView;
            dvTo.RowFilter = "Receiver_Type=2";

            gvTo.DataSource = dvTo;
            gvTo.DataBind();


            for (int i = 0; i < gvTo.Rows.Count; i++)
            {
                dtTo = dvTo.ToTable();
                DropDownList ddl = (DropDownList)gvTo.Rows[i].FindControl("ddlSortTo");
                ddl.SelectedValue = dtTo.Rows[i]["Sort_By"].ToString();

            }
           

            lstMember.SelectedIndex = -1;
        }
        protected void btnToRemove_OnClick(object sender, EventArgs e)
        {
            EIPEDMS objEDMS = new EIPEDMS();
            string Result = "";

            DataTable dtTo = ViewState["PAM"] as DataTable;

            foreach (GridViewRow gvrTo in gvTo.Rows)
            {
                CheckBox chkSelect = gvrTo.FindControl("chkSelect") as CheckBox;

                if (chkSelect.Checked == true)
                {
                    Label lblMember_Id = gvrTo.FindControl("lblMember_Id") as Label;

                    Result = objEDMS.Delete_Project_Alert_Members(ddlProject.SelectedValue, lblMember_Id.Text, Member);

                    if (dtTo.Rows.Find(lblMember_Id.Text) != null)
                    {
                        dtTo.Rows.Find(lblMember_Id.Text).Delete();
                    }              
                }
            }
            ViewState["PAM"] = dtTo;

            DataView dvTo = dtTo.DefaultView;
            dvTo.RowFilter = "Receiver_Type=2";
           
            gvTo.DataSource = dvTo;
            gvTo.DataBind();

            for (int i = 0; i < gvTo.Rows.Count; i++)
            {
                dtTo = dvTo.ToTable();
                DropDownList ddl = (DropDownList)gvTo.Rows[i].FindControl("ddlSortTo");
                ddl.SelectedValue = dtTo.Rows[i]["Sort_By"].ToString();

            }
        }

        protected void btnCcAdd_OnClick(object sender, EventArgs e)
        {
            EIPEDMS objEDMS = new EIPEDMS();
            DataTable dtCc = ViewState["PAM"] as DataTable;

            DataRow drCc;

            if (lstMember.SelectedIndex > -1)
            {
                for (int i = 0; i < lstMember.Items.Count; i++)
                {
                    if (lstMember.Items[i].Selected)
                    {
                        DataColumn[] dtCcAttachmentPK = new DataColumn[1];
                        dtCcAttachmentPK[0] = dtCc.Columns["Member_Id"];
                        dtCc.PrimaryKey = dtCcAttachmentPK;

                        if (dtCc.Rows.Find(lstMember.Items[i].Value) == null)
                        {
                            drCc = dtCc.NewRow();
                            drCc["Member_Name"] = lstMember.Items[i].Text;
                            drCc["Member_Id"] = lstMember.Items[i].Value;

                            if (gvCc.Rows.Count >= 0)
                            {
                                for (int j = 0; j <= gvCc.Rows.Count; j++)
                                {
                                    drCc["Sort_By"] = 1 + j;
                                }
                            }

                            drCc["Receiver_Type"] = "3";

                            dtCc.Rows.Add(drCc);
                        }
                    }
                }
            }

            ViewState["PAM"] = dtCc;

            DataView dvCc = dtCc.DefaultView;
            dvCc.RowFilter = "Receiver_Type=3";

            gvCc.DataSource = dvCc;
            gvCc.DataBind();

            for (int i = 0; i < gvCc.Rows.Count; i++)
            {
                dtCc = dvCc.ToTable();
                DropDownList ddl = (DropDownList)gvCc.Rows[i].FindControl("ddlSortCc");
                ddl.SelectedValue = dtCc.Rows[i]["Sort_By"].ToString();

            }

            lstMember.SelectedIndex = -1;

        }

        protected void btnCcRemove_OnClick(object sender, EventArgs e)
        {
            EIPEDMS objEDMS = new EIPEDMS();
            string Result = "";

            DataTable dtCc = ViewState["PAM"] as DataTable;

            foreach (GridViewRow gvrCc in gvCc.Rows)
            {
                CheckBox chkSelect = gvrCc.FindControl("chkSelect") as CheckBox;

                if (chkSelect.Checked == true)
                {
                    Label lblMember_Id = gvrCc.FindControl("lblMember_Id") as Label;

                    Result = objEDMS.Delete_Project_Alert_Members(ddlProject.SelectedValue, lblMember_Id.Text, Member);

                    if (dtCc.Rows.Find(lblMember_Id.Text) != null)
                    {
                        dtCc.Rows.Find(lblMember_Id.Text).Delete();
                    }
                }
            }
            ViewState["PAM"] = dtCc;
            DataView dvCc = dtCc.DefaultView;
            dvCc.RowFilter = "Receiver_Type=3";

            gvCc.DataSource = dvCc;
            gvCc.DataBind();
            for (int i = 0; i < gvCc.Rows.Count; i++)
            {
                dtCc = dvCc.ToTable();
                DropDownList ddl = (DropDownList)gvCc.Rows[i].FindControl("ddlSortCc");
                ddl.SelectedValue = dtCc.Rows[i]["Sort_By"].ToString();

            }
           
        }
        protected void btnBccAdd_OnClick(object sender, EventArgs e)
        {
            EIPEDMS objEDMS = new EIPEDMS();
            DataTable dtBcc = ViewState["PAM"] as DataTable;

            DataRow drBcc;

            if (lstMember.SelectedIndex > -1)
            {
                for (int i = 0; i < lstMember.Items.Count; i++)
                {
                    if (lstMember.Items[i].Selected)
                    {
                        DataColumn[] dtBccAttachmentPK = new DataColumn[1];
                        dtBccAttachmentPK[0] = dtBcc.Columns["Member_Id"];
                        dtBcc.PrimaryKey = dtBccAttachmentPK;

                        if (dtBcc.Rows.Find(lstMember.Items[i].Value) == null)
                        {
                            drBcc = dtBcc.NewRow();
                            drBcc["Member_Name"] = lstMember.Items[i].Text;
                            drBcc["Member_Id"] = lstMember.Items[i].Value;
                            if (gvBcc.Rows.Count >= 0)
                            {
                                for (int j = 0; j <= gvBcc.Rows.Count; j++)
                                {
                                    drBcc["Sort_By"] = 1 + j;
                                }
                            }
                            drBcc["Receiver_Type"] = "4";

                            dtBcc.Rows.Add(drBcc);
                        }
                    }
                }
            }

            ViewState["PAM"] = dtBcc;

            DataView dvBcc = dtBcc.DefaultView;
            dvBcc.RowFilter = "Receiver_Type=4";

            gvBcc.DataSource = dvBcc;
            gvBcc.DataBind();
            for (int i = 0; i < gvBcc.Rows.Count; i++)
            {
                dtBcc = dvBcc.ToTable();
                DropDownList ddl = (DropDownList)gvBcc.Rows[i].FindControl("ddlSortBcc");
                ddl.SelectedValue = dtBcc.Rows[i]["Sort_By"].ToString();

            }
            lstMember.SelectedIndex = -1;
        }

        protected void btnBccRemove_OnClick(object sender, EventArgs e)
        {
            EIPEDMS objEDMS = new EIPEDMS();
            string Result = "";

            DataTable dtBcc = ViewState["PAM"] as DataTable;

            foreach (GridViewRow gvrBcc in gvBcc.Rows)
            {
                CheckBox chkSelect = gvrBcc.FindControl("chkSelect") as CheckBox;

                if (chkSelect.Checked == true)
                {
                    Label lblMember_Id = gvrBcc.FindControl("lblMember_Id") as Label;

                    Result = objEDMS.Delete_Project_Alert_Members(ddlProject.SelectedValue, lblMember_Id.Text, Member);

                    if (dtBcc.Rows.Find(lblMember_Id.Text) != null)
                    {
                        dtBcc.Rows.Find(lblMember_Id.Text).Delete();
                    }
                }
            }
            ViewState["PAM"] = dtBcc;

            DataView dvBcc = dtBcc.DefaultView;
            dvBcc.RowFilter = "Receiver_Type=4";

            gvBcc.DataSource = dvBcc;
            gvBcc.DataBind();
            for (int i = 0; i < gvBcc.Rows.Count; i++)
            {
                dtBcc = dvBcc.ToTable();
                DropDownList ddl = (DropDownList)gvBcc.Rows[i].FindControl("ddlSortBcc");
                ddl.SelectedValue = dtBcc.Rows[i]["Sort_By"].ToString();
            }
        }

        protected void gvTo_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                EIPEDMS objEDMS = new EIPEDMS();

                DataTable dtTo = ViewState["PAM"] as DataTable;

                DataView dvTo = dtTo.DefaultView;

                dvTo.RowFilter = "Receiver_Type=2";

                DropDownList ddlSortTo = (DropDownList)e.Row.Cells[2].FindControl("ddlSortTo");
                
              
                ddlSortTo.DataSource = dvTo;
               
                ddlSortTo.DataTextField = "Sort_By";
                ddlSortTo.DataValueField = "Sort_By";
                
                ddlSortTo.DataBind();

                //int Count = gvTo.Rows.Count;
                //for (int i=0 ; i<Count; i++)
                //{
                //   DropDownList ddl = (DropDownList)gvTo.Rows[i].FindControl("ddlSortTo");
                //   ddl.SelectedValue=dtTo.Rows[i]["Sort_By"].ToString();
                 
                //}

            }
        }

        protected void gvCc_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                EIPEDMS objEDMS = new EIPEDMS();

                DataTable dtCc = ViewState["PAM"] as DataTable;

                DataView dvCc = dtCc.DefaultView;

                dvCc.RowFilter = "Receiver_Type=3";

                DropDownList ddlSortCc = (DropDownList)e.Row.Cells[2].FindControl("ddlSortCc");


                ddlSortCc.DataSource = dvCc;

                ddlSortCc.DataTextField = "Sort_By";
                ddlSortCc.DataValueField = "Sort_By";

                ddlSortCc.DataBind();

                //for (int i = 0; i < gvCc.Rows.Count; i++)
                //{
                //    DropDownList ddl = (DropDownList)gvCc.Rows[i].FindControl("ddlSortCc");
                //    ddl.SelectedValue = dtCc.Rows[i]["Sort_By"].ToString();

                //}

            }
        }

        protected void gvBcc_RowDataBound(object sender, GridViewRowEventArgs e)
        {
            if (e.Row.RowType == DataControlRowType.DataRow)
            {
                EIPEDMS objEDMS = new EIPEDMS();

                DataTable dtBcc = ViewState["PAM"] as DataTable;

                DataView dvBcc = dtBcc.DefaultView;

                dvBcc.RowFilter = "Receiver_Type=4";

                DropDownList ddlSortBcc = (DropDownList)e.Row.Cells[2].FindControl("ddlSortBcc");


                ddlSortBcc.DataSource = dvBcc;

                ddlSortBcc.DataTextField = "Sort_By";
                ddlSortBcc.DataValueField = "Sort_By";

                ddlSortBcc.DataBind();

                //for (int i = 0; i < gvBcc.Rows.Count; i++)
                //{
                //    DropDownList ddl = (DropDownList)gvBcc.Rows[i].FindControl("ddlSortBcc");
                //    ddl.SelectedValue = dtBcc.Rows[i]["Sort_By"].ToString();

                //}

            }
        }

        protected void ddlSortTo_OnSelectedIndexChanged(object sender, EventArgs e)
        {
            GridViewRow gvr = (GridViewRow)((DropDownList)sender).Parent.Parent;
            string celltext = gvr.Cells[2].Text  ;   //give the another cell index
            DropDownList ddl = (DropDownList)sender;
            if (celltext == ddl.SelectedValue)
            {
                //compare the value
            }

        }
        protected void ddlSortCc_OnSelectedIndexChanged(object sender, EventArgs e)
        {
            GridViewRow gvr = (GridViewRow)((DropDownList)sender).Parent.Parent;
            string celltext = gvr.Cells[1].Text;      //give the another cell index
            DropDownList ddl = (DropDownList)sender;
            if (celltext == ddl.SelectedValue)
            {
                //compare the value
            }
        }
        protected void ddlSortBcc_OnSelectedIndexChanged(object sender, EventArgs e)
        {
            GridViewRow gvr = (GridViewRow)((DropDownList)sender).Parent.Parent;
            string celltext = gvr.Cells[1].Text;      //give the another cell index
            DropDownList ddl = (DropDownList)sender;
            if (celltext == ddl.SelectedValue)
            {
                //compare the value
            }
        }


      

    }
}
